Merge "aarch64: Fix missing qemu-aarch64-static in chroot" into stable/danube
[yardstick.git] / tools / yardstick-img-modify
1 #!/bin/bash
2
3 ##############################################################################
4 # Copyright (c) 2015 Ericsson AB and others.
5 #
6 # All rights reserved. This program and the accompanying materials
7 # are made available under the terms of the Apache License, Version 2.0
8 # which accompanies this distribution, and is available at
9 # http://www.apache.org/licenses/LICENSE-2.0
10 ##############################################################################
11
12 # yardstick-img-modify - download and modify a Ubuntu cloud image
13 #
14 # The actual customization is done by a script passed with an absolute path as
15 # the only single argument. The command needs to be invoked as sudo
16 #
17 # Example invocation:
18 # yardstick-img-modify /home/yardstick/tools/ubuntu-server-cloudimg-modify.sh
19 #
20 # Warning: the script will create files by default in:
21 #   /tmp/workspace/yardstick
22 # the files will be owned by root!
23 #
24 # TODO: image resize is needed if the base image is too small
25 #
26 set -e
27 set -x
28
29 die() {
30     echo "error: $1" >&2
31     exit 1
32 }
33
34 test $# -eq 1 -o $# -eq 2 || die "no image specific script as argument"
35 test $(id -u) -eq 0 || die "should invoke using sudo"
36
37 cmd=$1
38 RELEASE=$2
39 test -x $cmd
40 mountdir="/mnt/yardstick"
41 workspace=${WORKSPACE:-"/tmp/workspace/yardstick"}
42 host=${HOST:-"cloud-images.ubuntu.com"}
43 release=${RELEASE:-"xenial"}
44 boot_mode="disk1"
45 if [[ "${YARD_IMG_ARCH}" = "arm64" ]]; then
46     boot_mode="uefi1"
47 fi
48
49 image_path="${release}/current/${release}-server-cloudimg-${YARD_IMG_ARCH}-${boot_mode}.img"
50 image_url=${IMAGE_URL:-"https://${host}/${image_path}"}
51 sha256sums_path="${release}/current/SHA256SUMS"
52 sha256sums_url=${SHA256SUMS_URL:-"https://${host}/${sha256sums_path}"}
53
54 imgfile="${workspace}/yardstick-image.img"
55 raw_imgfile_basename="yardstick-${release}-server.raw"
56 raw_imgfile="${workspace}/${raw_imgfile_basename}"
57 filename=$(basename $image_url)
58
59 apt-get install -y parted
60
61 # download and checksum base image, conditionally if local copy is outdated
62 download() {
63     test -d $workspace || mkdir -p $workspace
64     cd $workspace
65     rm -f SHA256SUMS # always download the checksum file to a detect stale image
66     wget $sha256sums_url
67     test -e $filename || wget -nc --progress=dot:giga $image_url
68     grep $filename SHA256SUMS | sha256sum -c ||
69     if [ $? -ne 0 ]; then
70         rm $filename
71         wget -nc --progress=dot:giga $image_url
72         grep $filename SHA256SUMS | sha256sum -c
73     fi
74
75     for i in $(seq 0 9); do
76         [ -a /dev/loop$i ] || mknod -m 660 /dev/loop$i b 7 $i
77     done
78
79     if [[ "${YARD_IMG_ARCH}" = "arm64"  && "$release" = "vivid" ]]; then
80         cd /tmp
81         if [ ! -f /tmp/${release}-server-cloudimg-${YARD_IMG_ARCH}-kernel-info.txt ]; then
82             wget http://${host}/${release}/current/${release}-server-cloudimg-${YARD_IMG_ARCH}-kernel-info.txt
83         fi
84         export CLOUD_KERNEL_VERSION=$(cut -d$'\t' -f4 ${release}-server-cloudimg-${YARD_IMG_ARCH}-kernel-info.txt)
85
86         mkdir -p /tmp/${release}-modules
87         if [ ! -f "/tmp/${release}-server-cloudimg-${YARD_IMG_ARCH}.tar.gz" ]; then
88             wget $CLOUD_IMG_URL
89         fi
90         if [ ! -f "/tmp/${release}-server-cloudimg-${YARD_IMG_ARCH}.img" ]; then
91             tar zxvf ${release}-server-cloudimg-${YARD_IMG_ARCH}.tar.gz ${release}-server-cloudimg-${YARD_IMG_ARCH}.img
92         fi
93         mkdir -p /mnt/${release}
94         mount /tmp/${release}-server-cloudimg-${YARD_IMG_ARCH}.img /mnt/${release}
95         cp -r /mnt/${release}/lib/modules/$(echo $CLOUD_KERNEL_VERSION) /tmp/${release}-modules
96         umount /mnt/${release}
97         rm /tmp/${release}-server-cloudimg-${YARD_IMG_ARCH}.img
98         cd $workspace
99     fi
100     qemu-img convert $filename $raw_imgfile
101     cd -
102 }
103
104 # mount image
105 setup() {
106     # qemu-img resize $raw_imgfile +5GB
107     mkdir -p $mountdir
108
109     loopdevice=$(kpartx -l $raw_imgfile | head -1 | cut -f1 -d ' ')
110
111     kpartx -av $raw_imgfile
112
113     if [[ "${YARD_IMG_ARCH}" = "arm64" && "$release" = "vivid" ]]; then
114         e2fsck -p -f /dev/mapper/$loopdevice
115         resize2fs /dev/mapper/$loopdevice
116     fi
117     # for trouble shooting
118     sleep 2
119     dmsetup ls
120     parted -l /dev/${loopdevice:0:5} || true
121     mount /dev/mapper/$loopdevice $mountdir
122     mount -t proc none $mountdir/proc
123
124     if [[ "${YARD_IMG_ARCH}" = "arm64" && "$release" = "vivid" ]]; then
125         cp -r /tmp/${release}-modules/$(echo $CLOUD_KERNEL_VERSION) "$mountdir/lib/modules"
126         cp $(which "qemu-aarch64-static") "$mountdir/usr/bin"
127     fi
128     cp $cmd $mountdir/$(basename $cmd)
129     if [ "${YARD_IMG_ARCH}" = "arm64" ]; then
130         cp /usr/bin/qemu-aarch64-static $mountdir/usr/bin
131     fi
132 }
133
134 # modify image running a script using in a chrooted environment
135 modify() {
136     # resolv.conf does not exist in base image, pass nameserver value from host
137     nameserver_ip=$(grep -m 1 '^nameserver' \
138         /etc/resolv.conf | awk '{ print $2 '})
139
140     # prevent init scripts from running during install
141     echo $'#!/bin/sh\nexit 101' >$mountdir/usr/sbin/policy-rc.d
142     chmod a+x $mountdir/usr/sbin/policy-rc.d
143
144     chroot $mountdir /$(basename $cmd) $nameserver_ip
145
146     rm -rf $mountdir/usr/sbin/policy-rc.d
147
148     umount -f $mountdir/proc
149     umount $mountdir
150
151     qemu-img convert -c -o compat=0.10 -O qcow2 $raw_imgfile $imgfile
152
153     if dmsetup table | grep $loopdevice; then
154        dmsetup clear $loopdevice || true
155     fi
156 }
157
158 # cleanup (umount) the image
159 cleanup() {
160     # designed to be idempotent
161     mount | grep $mountdir/proc && umount $mountdir/proc
162     mount | grep $mountdir && umount $mountdir
163     mount | grep "/mnt/${release}" && umount "/mnt/${release}"
164
165     if [ -f "${raw_imgfile}" ]; then
166         #kpartx -dv $raw_imgfile sometimes failed, we should checked it agein.
167         #if [ -z "$(kpartx -l $raw_imgfile | grep 'loop deleted')" ]; then
168         #    kpartx -dv $raw_imgfile
169         #fi
170         kpartx -dv $raw_imgfile || true
171     fi
172
173     rm -f $raw_imgfile
174     rm -rf $mountdir
175 }
176
177 exitcode=""
178 error_trap()
179 {
180     local rc=$?
181
182     set +e
183
184     if [ -z "$exitcode" ]; then
185         exitcode=$rc
186     fi
187
188     dmesg -T | tail -50
189
190     cleanup
191
192     echo "Image build failed with $exitcode"
193
194     exit $exitcode
195 }
196
197 main() {
198     cleanup
199
200     trap "error_trap" EXIT SIGTERM
201
202     download
203     setup
204     modify
205
206     trap - EXIT SIGTERM
207     cleanup
208
209     echo "the modified image is found here: $imgfile"
210 }
211
212 main
213